/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1998-2016 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <time.h>
#include <sys/time.h>

struct timeval tvBegin;

int timeval_subtract(struct timeval *result, struct timeval *t2, struct timeval *t1)
{
    long int diff = 1000000 * (t2->tv_sec - t1->tv_sec) + (t2->tv_usec - t1->tv_usec);
        /*(t2->tv_usec + 1000000 * t2->tv_sec) - (t1->tv_usec + 1000000 * t1->tv_sec);*/
    result->tv_sec = diff / 1000000;
    result->tv_usec = diff % 1000000;

    return (diff<0);
}



 int myclock() 
{
#if defined (__MINGW) || defined(__MINGW32__)
    return clock()/80;
#else
    return clock()/1000;
#endif    
}

void text_out(char *txt)
{
    printf("%d:: %s\n",myclock(),txt);fflush(stdout);
}

void text_out_new(char *txt)
{
    struct timeval tvEnd, tvDiff;
    
    gettimeofday(&tvEnd, NULL);
    timeval_subtract(&tvDiff, &tvEnd, &tvBegin);
    #if defined(__APPLE__) && defined(__MACH__)
    printf("%ld.%06d:: %s\n",tvDiff.tv_sec, tvDiff.tv_usec,txt);fflush(stdout);
    #else
    printf("%ld.%06ld:: %s\n",tvDiff.tv_sec, tvDiff.tv_usec,txt);fflush(stdout);
    #endif
}

void scan_sensor(char *txt, int *temp) 
{
    text_out(txt);
    scanf("%d",temp);
}

void scan_sensor_new(char *txt, int *temp) 
{
    text_out_new(txt);
    scanf("%d",temp);
}

void assertion(char *aname, int val) 
{
    printf("!PROG: assert %s:%d:%d:!\n",aname, val, myclock());fflush(stdout);
}



void assertion_new(char *aname, long int val) 
{
    struct timeval tvEnd, tvDiff;
    
    gettimeofday(&tvEnd, NULL);
    timeval_subtract(&tvDiff, &tvEnd, &tvBegin);
    #if defined(__APPLE__) && defined(__MACH__)
    printf("!PROG: assert %s:%ld:%ld:%06d:!\n",aname, val, tvDiff.tv_sec, tvDiff.tv_usec);fflush(stdout);
#else
    printf("!PROG: assert %s:%ld:%ld:%06ld:!\n",aname, val, tvDiff.tv_sec, tvDiff.tv_usec);fflush(stdout);
#endif
}



void assertion1(char *aname, int val) 
{
    printf("!PROG: assert %s:%d:%d:%d:%d:!\n",aname, val, 1,2,myclock());fflush(stdout);
}
