/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2016 Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of random and Random
 */

/* run */ define test0() = {
   exists X : {
       set random_seed=0 and
    len(10) and
    always ( (X=random) and format("X=%t \n",X) )
   }
}.

/* run */ define test1() = {
exists X : {
    len(10) and set random_seed=1 and
    format("Example of generating random numbers between 0 and 3\n")
    and
    format("Numbers will be 1 1 1 3 1 2 3 2 0 3 0\n") and
    always ( (X=random mod 4) and format("X=%t \n",X) )
   }
}.

/* run */ define test2() = 
{
    set random_seed=0 and
    empty and forall i<10 : format("i=%d and random=%d\n",i,random)
}.

/* run */ define test3() = 
{ exists X : {
        set random_seed=0 and
    len(10) and list(X,10) and stable(struct(X)) and
    always ( forall i<10 : (X[i]=random mod 9) and format("X=%t\n",X))
  }   
}.

/* run */ define test4() = 
{
    set random_seed=0 and
    len(3) and 
    always ( 
        {forall i<3 :  format("%t\n",random mod 2 = random mod 2)} )
}.

/* run */ define test5() = {
   exists X : {
       set random_seed=0 and
    len(10) and
    always ( (X=Random) and format("X=%t \n",X) )
   }
}.

/* run */ define test6() = {
exists X : {
    len(10) and set random_seed=1 and
    format("Example of generating Random numbers between 0 and 3\n")
    and
    format("Numbers will be 0 3 1 3 0 0 2 0 0 0 0\n") and
    always ( (X=Random mod 4) and format("X=%t \n",X) )
   }
}.

/* run */ define test7() = 
{
    set random_seed=0 and
    empty and forall i<10 : format("i=%d and Random=%d\n",i,Random)
}.

/* run */ define test8() = 
{ exists X : {
        set random_seed=0 and
    len(10) and list(X,10) and stable(struct(X)) and
    always ( forall i<10 : (X[i]=Random mod 9) and format("X=%t\n",X))
  }   
}.

/* run */ define test9() = 
{
    set random_seed=0 and
    len(3) and 
    always ( 
        {forall i<3 :  format("%t\n",Random mod 2 = Random mod 2)} )
}.

/* run */ define test10() = 
{ exists X : {
        set random_seed=0 and
    len(10) and list(X,3) and stable(struct(X)) and
    always ( forall i< 3 : (X[i]=fRandom) and format("X=%t\n",X))
    }
}.

/* run */ define test11() = 
{ exists X : {
        set random_seed=0 and
    len(10) and list(X,3) and stable(struct(X)) and
    always ( forall i< 3 : (X[i]=frandom) and format("X=%t\n",X))
    }
}.
    
