/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2015-2016 Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

define bits=[1,2,4,8,16,32,64,128].

define hex="0123456789ABCDEF".

define hexbinnib (X) = {
  if ((ascii(X) >= 48) and (ascii(X) <= 57)) then {ascii(X) - 48}
  else {
   if ((ascii(X) >= 65) and (ascii(X) <= 70)) then {ascii (X) - 55}
   else {format("*** Format Error in Input ***")}}
}.

define hexbinbyte (X,Y) = {hexbinnib (Y) + 16 * hexbinnib (X) }.

define bit (Bitno, Number)= {(Number div bits[Bitno]) mod 2}.

define prnbyte (R) = {
  format("%s\n", hex[R mod 16]+hex[R div 16] )
}.

define byte (R) = {
    hex[R mod 16]+hex[R div 16]
}.
    
define inttobits(X) = {
  [bit(0,X),bit(1,X),bit(2,X),bit(3,X),
   bit(4,X),bit(5,X),bit(6,X),bit(7,X)]
}.

define bitstoint(X) = {
  {if X[0] then 128 else 0} +
  {if X[1] then 64 else 0} +
  {if X[2] then 32 else 0} +
  {if X[3] then 16 else 0} +
  {if X[4] then 8 else 0} +
  {if X[5] then 4 else 0} +
  {if X[6] then 2 else 0} +
  {if X[7] then 1 else 0}
}.

define count_ones(X) = {
    if |X| = 0 then 0
        else {
            (if X[0] = 1 then 1 else 0)+count_ones(X[1..|X|])
        }    
}.

define no_ch(A,B,C,D) = {
    keep ( A:=A and B:=B and C:=C and D:=D )
}.

define no_ch_7(A,B,C,D,E,F,G) = {
    keep ( A:=A and B:=B and C:=C and D:=D and E:=E and F:=F and G:=G)
}.

define no_ch_list(A) = 
{
    keep ( (forall i<|A| : { A[i]:=A[i] } ))
}.

define all(A) =
{
    if |A| = 1
    then A[0]
        else A[0] + all(A[1..|A|])
}.
    
define message(X,n,k) = 
{
    set outfile = "stdout" and empty and
     format("%s width = %d and height = %d \n",X,n*8,k*8)
}.
    

    
    
